/*
 * Copyright (C) 2003-2004 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

//
// @author Marco Magistrali
// @version $Id: SyncMLDMConfig.cpp,v 1.0 2004/04/27 11:21:00 magi Exp $
//
#ifndef INCL_DM_SYNCMLDMBUILDER
    #define INCL_DM_SYNCMLDMBUILDER

    #include "http/common/Constants.h"
    #include "spds/common/Constants.h"    
    #include "spdm/common/Constants.h"
    #include "spdm/common/ManagementNode.h"
       
    #include "spdm/win32/SyncMLDMConfig.h"    
    #include "spdm/win32/DevInfo.h"
    #include "common/Log.h"
    #include "ptypes/ptypes.h"
    
    USING_PTYPES
    
    class __declspec(dllexport) SyncMLDMBuilder {
        
    private:
        
        void     createDevInfoMessage    (string &msg, DevInfo *devInfo, int cmdId);
        wchar_t* createMD5CredentialData (SyncMLDMConfig *syncMLDMConfig);
        void     calculateMD5            (char *token, char *digest);

        void     encodeBase64            (char *token, char *base64);
        void     decodeBase64            (char *base64, char *token);
    
    public:

        SyncMLDMBuilder();

        /*
         * Create the init message and returns it. 
         */
        wchar_t* createInitMessage( SyncMLDMConfig* syncMLDMConfig, 
                                    DevInfo* devInfo, wchar_t* DMSessionId, 
                                    int *cmdId, int *msgId, 
                                    BOOL isClientNotified, wchar_t* authStatusMsg);

        wchar_t* createSyncHdrStatusMessage(int *cmdId, int serverMsgId, SyncMLDMConfig* syncMLDMConfig, DevInfo* devInfo);
        
        /*
         * Create message with status of every command and Replace if Get command extsts and returns it. 
         */
        wchar_t* createResponseStatusMessage(SyncMLDMConfig* syncMLDMConfig, DevInfo* devInfo,  
                                    wchar_t* DMSessionId, 
                                    int *cmdId, int *msgId, wchar_t* responseStatusMsg,
                                    wchar_t* authStatusMsg);
        
        


        wchar_t* createReplaceStatusMessage(int msgRef, wchar_t *cmdRef, int *cmdId, 
                                    string &targetRef, int data, BOOL onlyOneStatus);
        
        wchar_t* createExecStatusMessage(int msgRef, wchar_t *cmdRef, int *cmdId, 
                                    string& targetRef, int data, BOOL onlyOneStatus);
        wchar_t* createGetStatusMessage(int msgRef, wchar_t *cmdRef, int *cmdId, string &targetRef, int data, BOOL onlyOneStatus);

        wchar_t* createResultsMessage(wchar_t* locUri, wchar_t* data, BOOL isNode);
        void completeResults(string &results, int msgRef, wchar_t *cmdRef, int cmdId );

       
    };
#endif